// Beycan Kahraman
//       040020337

#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define PI 3.1416
#define IZDUSUM_MERKEZI 2.5
#define KUCULTME_ORANI 90
#define CEMBER_DETAY   50   // min 30 olmal (3. soru icin gerekli)
#define BIR_BOLU_KOK_UC 0.57735

void SekliOlustur(float sekilX[], float sekilY[], float A, float B, int n){
    float derece = 0.0, artis = 2*PI / CEMBER_DETAY;
    int i;
    for(i=0; i<CEMBER_DETAY; i++){
        if(n == 0)
	    sekilX[i] = B*cos(derece) + A;
	else
            sekilX[i] = A*cos(derece) + A;
	sekilY[i] = B*sin(derece);
	derece   += artis;

    }
}

int EkranMaxX = 0, EkranMaxY = 0;

void DogruCiz(float x, float y){
    lineto((int)x, (int)(EkranMaxY - y));
}

void NoktayaGit(float x, float y){
    moveto((int)x, (int)(EkranMaxY - y));
}

void KupuOlustur(float sekil[]){
    sekil[0] = 1; sekil[10] = 0; sekil[20] = 0;
    sekil[1] = 1; sekil[11] = 1; sekil[21] = 0;
    sekil[2] = 0; sekil[12] = 1; sekil[22] = 0;
    sekil[3] = 0; sekil[13] = 0; sekil[23] = 0;
    sekil[4] = 1; sekil[14] = 0; sekil[24] = 1;
    sekil[5] = 1; sekil[15] = 1; sekil[25] = 1;
    sekil[6] = 0; sekil[16] = 1; sekil[26] = 1;
    sekil[7] = 0; sekil[17] = 0; sekil[27] = 1;
}
void KupuDondurIzdusurCiz(float sekil[], float yedek[], int sayac){
    int i;
    float izdusum;
    if(sayac < 30){
        izdusum = PI*sayac/180;
	for(i = 0; i<30; i++)
	    yedek[i] = sekil[i] + 2;
        for(i = 0; i<10; i++){
	    yedek[i]    = yedek[i]*cos(izdusum)    + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 - sin(izdusum)*(yedek[10+i] + yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[10+i] = yedek[10+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[10+i] - yedek[i] - yedek[20+i])/3 + sin(izdusum)*(yedek[i] - yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[20+i] = yedek[20+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 + sin(izdusum)*(yedek[i] + yedek[10+i])*BIR_BOLU_KOK_UC;
	}
	for(i = 0; i<30; i++)
	    yedek[i] = yedek[i] - 2;
    }else if(sayac < 61){
	izdusum = PI/6;
	for(i = 0; i<30; i++)
	    yedek[i] = sekil[i] + 2;
        for(i = 0; i<10; i++){
	    yedek[i]    = yedek[i]*cos(izdusum)    + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 - sin(izdusum)*(yedek[10+i] + yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[10+i] = yedek[10+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[10+i] - yedek[i] - yedek[20+i])/3 + sin(izdusum)*(yedek[i] - yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[20+i] = yedek[20+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 + sin(izdusum)*(yedek[i] + yedek[10+i])*BIR_BOLU_KOK_UC;
	}
	for(i = 0; i<30; i++)
	    yedek[i] = yedek[i] - 2;
	izdusum = (float)IZDUSUM_MERKEZI*(70 - sayac)/10;
	for(i = 0; i<10; i++){
	    yedek[i] = (izdusum*yedek[i]) / (izdusum - yedek[20+i]);
	    yedek[10+i] = (izdusum*yedek[10+i]) / (izdusum - yedek[20+i]);
        }
    }else{
	izdusum = PI/6;
	for(i = 0; i<30; i++)
	    yedek[i] = sekil[i] + 2;
        for(i = 0; i<10; i++){
	    yedek[i]    = yedek[i]*cos(izdusum)    + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 - sin(izdusum)*(yedek[10+i] + yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[10+i] = yedek[10+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[10+i] - yedek[i] - yedek[20+i])/3 + sin(izdusum)*(yedek[i] - yedek[20+i])*BIR_BOLU_KOK_UC;
	    yedek[20+i] = yedek[20+i]*cos(izdusum) + (1 - cos(izdusum))*(yedek[i] - yedek[10+i] + yedek[20+i])/3 + sin(izdusum)*(yedek[i] + yedek[10+i])*BIR_BOLU_KOK_UC;
	}
	for(i = 0; i<30; i++)
	    yedek[i] = yedek[i] - 2;
	for(i = 0; i<10; i++){   // 2.5 perspektif
	    yedek[i] = (IZDUSUM_MERKEZI*yedek[i]) / (IZDUSUM_MERKEZI - yedek[20+i]);
            yedek[10+i] = (IZDUSUM_MERKEZI*yedek[10+i]) / (IZDUSUM_MERKEZI - yedek[20+i]);
	}
	setcolor(10);
        if(sayac == 80){
	    printf("Aranan Kup : \n");
	    for(i=0; i<8; i++){
		printf("(%0.3f,%0.3f),", yedek[i], yedek[10+i]);
		if(i%2 == 1)
		    printf("\n");
	    }
	    printf("\n");
        }
    }

    for(i = 0; i<30; i++)
	yedek[i] = 50*yedek[i];
    moveto(yedek[4]+182, 80 - yedek[14]);

    lineto(yedek[0]+182, 80 - yedek[10]);
    lineto(yedek[1]+182, 80 - yedek[11]);
    lineto(yedek[2]+182, 80 - yedek[12]);
    lineto(yedek[3]+182, 80 - yedek[13]);
    lineto(yedek[7]+182, 80 - yedek[17]);
    lineto(yedek[4]+182, 80 - yedek[14]);
    lineto(yedek[5]+182, 80 - yedek[15]);
    lineto(yedek[6]+182, 80 - yedek[16]);
    lineto(yedek[7]+182, 80 - yedek[17]);
    line(yedek[0]+182, 80 - yedek[10], yedek[3]+182, 80 - yedek[13]);
    line(yedek[1]+182, 80 - yedek[11], yedek[5]+182, 80 - yedek[15]);
    line(yedek[2]+182, 80 - yedek[12], yedek[6]+182, 80 - yedek[16]);

}

float f(float x){
    return x*sin(x)*cos(x*x);
}
void DondurveCiz(float sekilX[], float sekilY[], int DondurmeYonu, float DonmeAcisi, int kay){
    int i;

    if(DondurmeYonu == 0)
	moveto(sekilX[CEMBER_DETAY - 1]*cos(DonmeAcisi) - sekilY[CEMBER_DETAY-1]*sin(DonmeAcisi) + kay, sekilX[CEMBER_DETAY-1]*sin(DonmeAcisi) + sekilY[CEMBER_DETAY-1]*cos(DonmeAcisi) + kay);
    else
	moveto(sekilX[CEMBER_DETAY - 1]*cos(DonmeAcisi) + kay, sekilY[CEMBER_DETAY-1] + kay);

    for(i=0; i<CEMBER_DETAY; i++)
	if(DondurmeYonu == 0)
	    lineto(sekilX[i]*cos(DonmeAcisi) - sekilY[i]*sin(DonmeAcisi) + kay, sekilX[i]*sin(DonmeAcisi) + sekilY[i]*cos(DonmeAcisi) + kay);
	else
	    lineto(sekilX[i]*cos(DonmeAcisi) + kay, sekilY[i] + kay);
}

void main(){
    int      i, soru, menu = 1;
    int      ARALIK;
    float    a, b, x, max, min, denemeAraligi, yedek;
    float    CemberX[CEMBER_DETAY], CemberY[CEMBER_DETAY],
    	     ElipsX [CEMBER_DETAY], ElipsY [CEMBER_DETAY];
    float    CizimX, CizimY;
    int      Adapter = 0, Mod;
    char     *dir = "C:\\TC\\BGI";
    void     *pt;
    unsigned int imsize;
    printf("\tBeycan Kahraman\n\t      040020337\n---------------------------------\n");
    while(menu){
	printf("Soru No'yu Giriniz (Cikis = 0) = ");
	scanf("%d", &soru);

        detectgraph(&Adapter, &Mod);
    	initgraph(&Adapter, &Mod, dir);

    	EkranMaxX = getmaxx();
	EkranMaxY = getmaxy();

	switch(soru){
	    case 1:
		printf("Fonksiyonun cizilecegi araligi giriniz\na = ");
		scanf("%f", &a);
		printf("b = ");
		scanf("%f", &b);

		printf("Fonksiyonun Cizilme Detayn Giriniz (10 - 1000 aras) = ");
		scanf("%d", &ARALIK);
		if(ARALIK < 10) ARALIK = 10;
		if(ARALIK > 1000) ARALIK = 1000;

		if(b < a){
		    yedek = a;
		    a = b;
		    b = yedek;
		}
               
		clearviewport();

		min = f(a);
                max = f(a);
		denemeAraligi = (b - a) / ARALIK;
		yedek = a;
		menu = 0;
		CemberX[0] = 10;
                CemberX[1] = 0;

		for(i=0; i<ARALIK; i++){
		    yedek += denemeAraligi;
		    if(f(yedek) > max)
			max = f(yedek);
		    if(f(yedek) < min)
			min = f(yedek);
		    if(f(yedek) < 0.001)
			soru = 10;
		    if(f(yedek) > -0.001)
			menu = 10;
		    if(f(yedek) > 0){
			if(f(yedek) < CemberX[0]){
			    CemberX[0] = f(yedek);
			    CemberX[1] = yedek;
                        }
		    }else{
			if(f(yedek) > -CemberX[0]){
			    CemberX[0] = -f(yedek);
			    CemberX[1] = yedek;
			}
		    }
		}

		yedek = (max - min) * (100 - KUCULTME_ORANI) / 100;
		max  += yedek;
		min  -= yedek;

                setcolor(10);
		if(b > -0.01 && a < 0.01){
		    CizimX = (EkranMaxX-20) * (0 - a) / (b - a) + 10;
		    line(CizimX, 0, CizimX, EkranMaxY);
		}
		if(menu == 10 && soru == 10){
		    CizimY = EkranMaxY * (f(CemberX[1]) - min) / (max - min);
		    line(0, EkranMaxY - CizimY, EkranMaxX, EkranMaxY - CizimY);
		}

		yedek  = a;
		CizimX = (EkranMaxX-20) * (yedek - a) / (b - a) + 10;
		CizimY = EkranMaxY * (f(yedek) - min) / (max - min);

		NoktayaGit(CizimX, CizimY);
		setcolor(12);

		for(i = 0; i<ARALIK; i++){
		    yedek += denemeAraligi;
		    CizimX = (EkranMaxX - 20) * (yedek - a) / (b - a) + 10;
                    CizimY = EkranMaxY * (f(yedek) - min) / (max - min);
		    DogruCiz(CizimX, CizimY);
		}

		getch();
		break;
	    case 2:
		imsize = (0, 0, 230, 200);
		pt = malloc(imsize);

		KupuOlustur(CemberX);
		i = 0;
                menu = 1;

		while(!kbhit()){
		    i = (i + menu) % 150;
                    //setactivepage(1);
		    //clearviewport();
                    if(i == 1){
                        printf("Donduruluyor\na = ");
		    }
                    if(i < 31 && i > 1)
			if(i%5 == 0)
			    printf("%d, ",i);
		    if(i == 30)
			printf("\nIzdusum Aliniyor...\nZc = ");
		    else if(i == 61)
			printf("\n");
		    if(i < 61 && i > 30){
			if(i %5 == 0)
			    printf("%0.2f, ", (float)IZDUSUM_MERKEZI * (70 - i) / 10.0);
		    }
		    
		    setactivepage(1);
		    clearviewport();
		    setcolor(12);
		    KupuDondurIzdusurCiz(CemberX, CemberY, i);
		    getimage(0, 0, 230, 200, pt);
		    setactivepage(0);
		    putimage(350, 0, pt, 0);
		    setvisualpage(0);
		}
		free(pt);
		break;
	    case 3:
		printf("Cember ve Elips icin a ve b degerlerini giriniz (10 - 50 aras)\na = ");
		scanf("%f", &a);
		if(a < 10) a = 10;
                if(a > 50) a = 50;
		printf("b = ");
		scanf("%f", &b);
		if(b < 10) a = 10;
		if(b > 50) a = 50;

		if(a < b){
		    yedek = a;
		    a = b;
		    b = yedek;
                }

		printf("Donus Ekseni (Nokta icin 0, Dogru icin 1) = ");
		scanf("%d", &soru);
		soru = soru > 0 ? 1 : 0;

                printf("Donus Hz (1 - 30 aras) = ");
		scanf("%d", &menu);
		if(menu > 30) menu = 30;
		if(menu < 1) menu = 1;

		imsize = (0, 0, 200, 200);
		pt = malloc(imsize);

		SekliOlustur(CemberX, CemberY, a, b, 0);
		SekliOlustur(ElipsX, ElipsY, a, b, 1);
                i = 0;

		while(!kbhit()){
		    i = (i + menu) % 360;
        	    setactivepage(1);
		    clearviewport();
		    setcolor(8);
		    line(0,2*a,200,2*a);
		    line(2*a,0,2*a,200);

		    setcolor(10);
		    DondurveCiz(ElipsX, ElipsY, soru, PI * i / 180.0, 2*a);
		    setcolor(12);
		    DondurveCiz(CemberX, CemberY, soru, PI * i / 180.0, 2*a);

		    getimage(0, 0, 200, 200, pt);
		    setactivepage(0);
		    putimage(50, 100, pt, 0);
		    setvisualpage(0);
		}
		free(pt);
		break;
	    default:
		menu = 0;
                break;
	}
        closegraph();
    }
}